\insert 'NewResourceArbiter.oz'
\insert 'TestingNoStop.oz'
declare
{StartTesting 'NewResourceArbiterTest $Revision: 1.1 $'}
proc {Acquire Port} % to avoid repeated testing code, for testing only
   local WaitVar in {Send Port reserve(WaitVar)} {Wait WaitVar} end
end

RA = {NewResourceArbiter}
{Test {Send RA query($)} '==' notUsed}
{Acquire RA}
{Test {Send RA query($)} '==' inUse}
{Send RA release}
{Test {Send RA query($)} '==' notUsed}

RA2 = {NewResourceArbiter}
local TestStrm P={NewPort TestStrm} in
   for ID in 1..2 do
      thread {Acquire RA2} {Send P ID} {Delay 5} {Send P ID} {Send RA2 release} end
   end
   local T4 = {List.take TestStrm 4} in
      {Test (T4 == [1 1 2 2] orelse T4 == [2 2 1 1]) '==' true}
   end
end
{StartTesting done}
